﻿(function () {

    "use strict";

    angular.module("EnrApp")
           .factory("primaryService", ["$rootScope", function ($rootScope) {

               // Service Interface
               var serviceInterface = {

                   setOfficesList: setOfficesList,
                   getOfficesList: getOfficesList,
                   setIsNumberOfSeats: setIsNumberOfSeats,
                   getIsNumberOfSeats: getIsNumberOfSeats,
                   setIsPrimary: setIsPrimary,
                   setSelectedParty: setSelectedParty,
                   getIsPrimary: getIsPrimary,
                   setPartyColors: setPartyColors,
                   getPartyColors: getPartyColors,
                   getSelectedPartyColor: getSelectedPartyColor,
                   getSelectedParty: getSelectedParty,
                   setIsCertified: setIsCertified,
                   getIsCertified: getIsCertified,
                   //setOfficesData: setOfficesData,
                   //getOfficesData: getOfficesData,
                   setOfficersJsonData: setOfficersJsonData,
                   getOfficersJsonData: getOfficersJsonData,
                   //Implemented for State Constitutional Amendment
                   getStateConReferendum: getStateConReferendum,
                   setStateConReferendum: setStateConReferendum,
                   isStateConReferendumExist: isStateConReferendumExist,
                   getMapDistrictData: getMapDistrictData,
                   setMapDistrictData: setMapDistrictData,
                   getIsMouseArrivedOnModel: getIsMouseArrivedOnModel,
                   setIsMouseArrivedOnModel: setIsMouseArrivedOnModel,
                   getElectionType: getElectionType,
                   setElectionType: setElectionType
               }


               // "Private" members
               var isPrimary = false;
               var selectedParty = null;
               var isSplash = null;
               var PartyColor = {
                   Republican: null,
                   Democrat: null
               };
               var isCertified = false;
               var isNumberOfSeats = null;
               var isMouseArrivedonModel = false;
             
               var officesList = [];
               var officersJsonData = [];
               var mapDistrictData = [];
               var stateConReferendumData = {};
               var isStateConReferendumData = false;
               var electionType;

               function getIsMouseArrivedOnModel() {
                   return isMouseArrivedonModel;
               }

               function setIsMouseArrivedOnModel(_isArrived) {
                   isMouseArrivedonModel = _isArrived;
               }
           
               function setOfficersJsonData(_setOfficersJsonData) {
                   officersJsonData = _setOfficersJsonData;
               }

               function getStateConReferendum() {
                   return stateConReferendumData;
               }

               function getMapDistrictData() {
                   return mapDistrictData;
               }

               function setMapDistrictData(_mapDistrictData) {
                   mapDistrictData = _mapDistrictData;
               }

               function isStateConReferendumExist() {
                   return isStateConReferendumData;
               }

               function setStateConReferendum(_stateConReferendumData) {
                   stateConReferendumData = _stateConReferendumData;
                   isStateConReferendumData = true;
                   $rootScope.$broadcast("STATE_CON_REFERENDUM");
               }

               function getOfficersJsonData() {
                   return officersJsonData;
               }

               function setIsPrimary(_isPrimary, _selectedParty) {
                   isPrimary = _isPrimary;
                   setSelectedParty(_selectedParty);

                   if (_isPrimary)
                       $rootScope.$broadcast("IS_PRIMARY_SET");
               }
               function setSelectedParty(_selectedParty,_isSplash) {
                   selectedParty = _selectedParty;
                   isSplash = _isSplash;
                   $rootScope.$broadcast("SELECTED_PARTY_CHANGED", selectedParty, isSplash);
               }
               function setIsCertified(_isCertified) {
                   isCertified = _isCertified;
               }
               function setIsNumberOfSeats(_isNumberOfSeats) {
                   isNumberOfSeats = _isNumberOfSeats;
               }

               function setOfficesList(_officesList) {
                   officesList = _officesList;
               }

               function getIsPrimary() {
                   return isPrimary;
               }
               function getSelectedParty() {
                   return selectedParty;
               }

               function getIsCertified() {
                   return isCertified;
               }
               function getIsNumberOfSeats() {
                   return isNumberOfSeats;
               }
               function setPartyColors(partyColors) {
                   PartyColor = partyColors;
               }
               function setElectionType(_electionType) {
                   electionType = _electionType;
               }
               function getElectionType() {
                   return electionType;
               }

               function getPartyColors() {
                   return PartyColor;
               }

               function getOfficesList() {
                   return officesList;
               }

               function getSelectedPartyColor() {
                   if (selectedParty === "D") {
                       return PartyColor.Democrat;
                   }
                   else  //if (selectedParty === "R")
                   {
                       return PartyColor.Republican;
                   }
               }
               return serviceInterface;
           }]);

}());